package com.javainuse.bank.service;

import com.javainuse.banking.AddressProofResponse;

import io.grpc.stub.StreamObserver;

public class ResponseObserver implements StreamObserver<AddressProofResponse> {
	private final Object lock = new Object();
	private boolean completed = false;

	@Override
	public void onNext(AddressProofResponse response) {
		System.out.println("Server response: " + response.getMessage());
	}

	@Override
	public void onError(Throwable throwable) {
		System.err.println("Error occurred: " + throwable.getMessage());
		synchronized (lock) {
			completed = true;
			lock.notifyAll();
		}
	}

	@Override
	public void onCompleted() {
		System.out.println("File uploaded successfully!");
		synchronized (lock) {
			completed = true;
			lock.notifyAll();
		}
	}

	public void awaitCompletion() {
		synchronized (lock) {
			while (!completed) {
				try {
					lock.wait();
				} catch (InterruptedException e) {
					e.printStackTrace();
				}
			}
		}
	}
}